//+-----------------------------------------------------------------+
//| Silver Trend, 2013 Version                                      |
//+-----------------------------------------------------------------+
//---- Indicator Settings
#property indicator_chart_window
#property indicator_buffers 2
//---- Input Parameters
extern int Risk     = 3  ;
extern int Bar      = 500;
extern int LookBack = 20 ;
//---- Buffers
double Buy  [];
double Sell [];
double Trend[];

//+-------------------------------------------------------+
//| Silver Trend Initialization Function                  |
//+-------------------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
   SetIndexBuffer(0,Buy );SetIndexDrawBegin(0,Bars-Bar+LookBack);SetIndexStyle(0,DRAW_ARROW,EMPTY,1,RoyalBlue);SetIndexArrow(0,233);SetIndexLabel(0,"Buy" );   
   SetIndexBuffer(1,Sell);SetIndexDrawBegin(1,Bars-Bar+LookBack);SetIndexStyle(1,DRAW_ARROW,EMPTY,1,Tomato   );SetIndexArrow(1,234);SetIndexLabel(1,"Sell");
   SetIndexBuffer(2,Trend);
//--- Initialization is done.
   return(0);
  }

//+-------------------------------------------------------+
//| Silver Trend Deinitialization Function                |
//+-------------------------------------------------------+
int deinit()
  {
   Comment("");
   return(0);
  }

//+-------------------------------------------------------+
//| Silver Trend Main Function                            |
//+-------------------------------------------------------+
int start()
  {
   Comment("Silver Trend, Look Back: "+LookBack);
   if (Bar >= Bars)  Bar = Bars;
   int CountedBars = IndicatorCounted();
   if (Bars < LookBack+1)  return(0);
   if (CountedBars < LookBack+1)
     {
      for(int i=1; i<=LookBack; i++)
        {
         Buy [Bar-i] = 0.0;
         Sell[Bar-i] = 0.0;
        }
     }
   int k = 33-Risk;
//---- Silver Trend Iteration Function
   for (int Shift=Bar-LookBack; Shift>=0; Shift--) 
     {
      double Range    = 0;
	   double AvgRange = 0;
	   for (int r=Shift; r<=Shift+LookBack; r++)  AvgRange += MathAbs(High[r]-Low[r]);
    	Range = AvgRange/(LookBack+1);
      double SSMax = High[Shift]; 
      double SSMin = Low [Shift]; 
      for (int t=Shift; t<=Shift+LookBack-1; t++)
        {
         double Price = High[t];
         if (SSMax < Price)   SSMax = Price;
         Price = Low[t];
         if (SSMin >= Price)  SSMin = Price;
        }
      double SMin = SSMin+(SSMax-SSMin)*k/100; 
      double SMax = SSMax-(SSMax-SSMin)*k/100; 
   	Trend[Shift] = Trend[Shift+1];
	   if (Close[Shift] < SMin) Trend[Shift] =-1;
	   if (Close[Shift] > SMax) Trend[Shift] = 1;
    	Buy [Shift] = EMPTY_VALUE;
	   Sell[Shift] = EMPTY_VALUE;
	   if (Trend[Shift]!= Trend[Shift+1])
      if (Trend[Shift] == 1)  Buy [Shift] = Low [Shift]-Range;
      else                    Sell[Shift] = High[Shift]+Range;
     }
   return(0);
  }
//+-------------------------------------------------------+